package argenteditor.editors;

import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.TextAttribute;
import org.eclipse.jface.text.presentation.IPresentationReconciler;
import org.eclipse.jface.text.presentation.PresentationReconciler;
import org.eclipse.jface.text.rules.DefaultDamagerRepairer;
import org.eclipse.jface.text.rules.RuleBasedScanner;
import org.eclipse.jface.text.rules.Token;
import org.eclipse.jface.text.source.ISourceViewer;
import org.eclipse.jface.text.source.SourceViewerConfiguration;

public class ArgentConfiguration extends SourceViewerConfiguration {

	private ColorManager colorManager;
	private ArgentScanner ascanner;

	public ArgentConfiguration(ColorManager colorManager) {
		this.colorManager = colorManager;
	}
	public String[] getConfiguredContentTypes(ISourceViewer sourceViewer) {
		return new String[] {
				IDocument.DEFAULT_CONTENT_TYPE,
				ArgentPartitionScanner.ARGENT,
				ArgentPartitionScanner.L_ARGENT //ǉ
				};
	}
	

	protected ArgentScanner getArgentScanner() { //߂lArgentScannerɂȂ
		
	if(ascanner==null){ //qɂ
		ascanner=new ArgentScanner(colorManager); //ArgentScanner̃IuWFNg
		
		ascanner.setDefaultReturnToken(
			new Token(
				new TextAttribute(
					colorManager.getColor(IArgentColorConstants.ARGENT))));
	}
		
		return ascanner;
}
	
	protected RuleBasedScanner getNormalScanner() {
		
		RuleBasedScanner scanner=new RuleBasedScanner();
		
			scanner.setDefaultReturnToken(
				new Token(
					new TextAttribute(
						colorManager.getColor(IArgentColorConstants.NORMAL))));
		
		return scanner;
		
}
	
	protected RuleBasedScanner getLittleArgentScanner() {
		
	RuleBasedScanner scanner=new RuleBasedScanner();
		
	scanner.setDefaultReturnToken(
		new Token(
			new TextAttribute(
				colorManager.getColor(IArgentColorConstants.L_ARGENT))));
		
	return scanner;
}

	public IPresentationReconciler getPresentationReconciler(ISourceViewer sourceViewer) {
		PresentationReconciler reconciler = new PresentationReconciler();

		DefaultDamagerRepairer dr =
			new DefaultDamagerRepairer(getArgentScanner());
		reconciler.setDamager(dr, ArgentPartitionScanner.ARGENT);
		reconciler.setRepairer(dr, ArgentPartitionScanner.ARGENT);
		
		dr = new DefaultDamagerRepairer(getLittleArgentScanner());
		reconciler.setDamager(dr, ArgentPartitionScanner.L_ARGENT);
		reconciler.setRepairer(dr, ArgentPartitionScanner.L_ARGENT);

		dr = new DefaultDamagerRepairer(getNormalScanner());
		reconciler.setDamager(dr, IDocument.DEFAULT_CONTENT_TYPE);
		reconciler.setRepairer(dr, IDocument.DEFAULT_CONTENT_TYPE);
		
		return reconciler;
	}

}