package argenteditor.editors;

import org.eclipse.jface.text.rules.*;

public class ArgentRule extends MultiLineRule {

	public ArgentRule(IToken token) {
		super("!", "?", token);
	}
	protected boolean sequenceDetected(
		ICharacterScanner scanner,
		char[] sequence,
		boolean eofAllowed) {
		int c = scanner.read();
		
		if (sequence[0] == '!') {
			if (c == '?') {
				scanner.unread();
				return false;
			}
				
		} else if (sequence[0] == '?') {
			scanner.unread();
		}
		
		return super.sequenceDetected(scanner, sequence, eofAllowed);
	}
}
