package argenteditor.editors;

import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.ITextDoubleClickStrategy;
import org.eclipse.jface.text.TextAttribute;
import org.eclipse.jface.text.presentation.IPresentationReconciler;
import org.eclipse.jface.text.presentation.PresentationReconciler;
import org.eclipse.jface.text.rules.DefaultDamagerRepairer;
import org.eclipse.jface.text.rules.RuleBasedScanner;
import org.eclipse.jface.text.rules.Token;
import org.eclipse.jface.text.source.ISourceViewer;
import org.eclipse.jface.text.source.SourceViewerConfiguration;

public class ArgentConfiguration extends SourceViewerConfiguration {

	private ColorManager colorManager;

	public ArgentConfiguration(ColorManager colorManager) {
		this.colorManager = colorManager;
	}
	public String[] getConfiguredContentTypes(ISourceViewer sourceViewer) {
		return new String[] {
				IDocument.DEFAULT_CONTENT_TYPE,
				ArgentPartitionScanner.ARGENT };
	}
	

	protected RuleBasedScanner getArgentScanner() {
		//Ǝ̃NXł͂ȂCRuleBasedScannerԂ
			
		RuleBasedScanner scanner=new RuleBasedScanner();
			
			scanner.setDefaultReturnToken(
				new Token(
					new TextAttribute(
						colorManager.getColor(IArgentColorConstants.ARGENT))));
			//scannerœǂݏoɂ͐ԂFCƂ悤ȏ
			
		return scanner;
	}
	
	protected RuleBasedScanner getNormalScanner() {
		
		RuleBasedScanner scanner=new RuleBasedScanner();
		
			scanner.setDefaultReturnToken(
				new Token(
					new TextAttribute(
						colorManager.getColor(IArgentColorConstants.NORMAL))));
		
		return scanner;
		
}

	public IPresentationReconciler getPresentationReconciler(ISourceViewer sourceViewer) {
		PresentationReconciler reconciler = new PresentationReconciler();

		DefaultDamagerRepairer dr =
			new DefaultDamagerRepairer(getArgentScanner());
		reconciler.setDamager(dr, ArgentPartitionScanner.ARGENT);
		reconciler.setRepairer(dr, ArgentPartitionScanner.ARGENT);

		dr = new DefaultDamagerRepairer(getNormalScanner());
		reconciler.setDamager(dr, IDocument.DEFAULT_CONTENT_TYPE);
		reconciler.setRepairer(dr, IDocument.DEFAULT_CONTENT_TYPE);
		
		return reconciler;
	}

}