package blackeditor.wizards;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.SWT;
import org.eclipse.jface.viewers.*;

/**
 * The "New" wizard page allows setting the container for
 * the new file as well as the file name. The page
 * will only accept file name without the extension OR
 * with the extension that matches the expected one (be).
 */

public class BlackNextWizardPage extends WizardPage {
	
	private List animaList;
	private ISelection selection;

	/**
	 * Constructor for SampleNewWizardPage.
	 * @param pageName
	 */
	public BlackNextWizardPage(ISelection selection) {
		
		super("Black-Editor wizardPage");
		setTitle("Dȓ́H");
		setDescription("IĂ");
		this.selection = selection;
	}

	/**
	 * @see IDialogPage#createControl(Composite)
	 */
	public void createControl(Composite parent) {
		Composite container = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 3;
		layout.verticalSpacing = 9;
		
		Label label = new Label(container, SWT.NULL);
		label.setText(":");

		animaList = new List(container, SWT.SINGLE);
		animaList.add("TC");
		animaList.add("M");
		animaList.add("wAtV");
		
		setControl(container);
	}
	
	public String getAnimalName() {
		return animaList.getItem(animaList.getSelectionIndex());
	}

	
}